<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="en"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>FollowerZooKeeperServer.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">Code Coverage for Zookeeper manuall provided Classes</a> &gt; <a href="index.source.html" class="el_package">org.apache.zookeeper.server.quorum</a> &gt; <span class="el_source">FollowerZooKeeperServer.java</span></div><h1>FollowerZooKeeperServer.java</h1><pre class="source lang-java linenums">/**
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * &quot;License&quot;); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an &quot;AS IS&quot; BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.zookeeper.server.quorum;

import java.io.IOException;
import java.util.concurrent.ConcurrentLinkedQueue;
import java.util.concurrent.LinkedBlockingQueue;

import org.apache.jute.Record;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.apache.zookeeper.server.FinalRequestProcessor;
import org.apache.zookeeper.server.Request;
import org.apache.zookeeper.server.RequestProcessor;
import org.apache.zookeeper.server.SyncRequestProcessor;
import org.apache.zookeeper.server.ZKDatabase;
import org.apache.zookeeper.server.persistence.FileTxnSnapLog;
import org.apache.zookeeper.txn.TxnHeader;

/**
 * Just like the standard ZooKeeperServer. We just replace the request
 * processors: FollowerRequestProcessor -&gt; CommitProcessor -&gt;
 * FinalRequestProcessor
 * 
 * A SyncRequestProcessor is also spawned off to log proposals from the leader.
 */
public class FollowerZooKeeperServer extends LearnerZooKeeperServer {
<span class="fc" id="L44">    private static final Logger LOG =</span>
<span class="fc" id="L45">        LoggerFactory.getLogger(FollowerZooKeeperServer.class);</span>

    CommitProcessor commitProcessor;

    SyncRequestProcessor syncProcessor;

    /*
     * Pending sync requests
     */
    ConcurrentLinkedQueue&lt;Request&gt; pendingSyncs;
    
    /**
     * @param port
     * @param dataDir
     * @throws IOException
     */
    FollowerZooKeeperServer(FileTxnSnapLog logFactory,QuorumPeer self,
            DataTreeBuilder treeBuilder, ZKDatabase zkDb) throws IOException {
<span class="fc" id="L63">        super(logFactory, self.tickTime, self.minSessionTimeout,</span>
                self.maxSessionTimeout, treeBuilder, zkDb, self);
<span class="fc" id="L65">        this.pendingSyncs = new ConcurrentLinkedQueue&lt;Request&gt;();</span>
<span class="fc" id="L66">    }</span>

    public Follower getFollower(){
<span class="fc" id="L69">        return self.follower;</span>
    }      

    @Override
    protected void setupRequestProcessors() {
<span class="fc" id="L74">        RequestProcessor finalProcessor = new FinalRequestProcessor(this);</span>
<span class="fc" id="L75">        commitProcessor = new CommitProcessor(finalProcessor,</span>
<span class="fc" id="L76">                Long.toString(getServerId()), true,</span>
<span class="fc" id="L77">                getZooKeeperServerListener());</span>
<span class="fc" id="L78">        commitProcessor.start();</span>
<span class="fc" id="L79">        firstProcessor = new FollowerRequestProcessor(this, commitProcessor);</span>
<span class="fc" id="L80">        ((FollowerRequestProcessor) firstProcessor).start();</span>
<span class="fc" id="L81">        syncProcessor = new SyncRequestProcessor(this,</span>
<span class="fc" id="L82">                new SendAckRequestProcessor((Learner)getFollower()));</span>
<span class="fc" id="L83">        syncProcessor.start();</span>
<span class="fc" id="L84">    }</span>

<span class="fc" id="L86">    LinkedBlockingQueue&lt;Request&gt; pendingTxns = new LinkedBlockingQueue&lt;Request&gt;();</span>

    public void logRequest(TxnHeader hdr, Record txn) {
<span class="fc" id="L89">        Request request = new Request(null, hdr.getClientId(), hdr.getCxid(),</span>
<span class="fc" id="L90">                hdr.getType(), null, null);</span>
<span class="fc" id="L91">        request.hdr = hdr;</span>
<span class="fc" id="L92">        request.txn = txn;</span>
<span class="fc" id="L93">        request.zxid = hdr.getZxid();</span>
<span class="pc bpc" id="L94" title="1 of 2 branches missed.">        if ((request.zxid &amp; 0xffffffffL) != 0) {</span>
<span class="fc" id="L95">            pendingTxns.add(request);</span>
        }
<span class="fc" id="L97">        syncProcessor.processRequest(request);</span>
<span class="fc" id="L98">    }</span>

    /**
     * When a COMMIT message is received, eventually this method is called, 
     * which matches up the zxid from the COMMIT with (hopefully) the head of
     * the pendingTxns queue and hands it to the commitProcessor to commit.
     * @param zxid - must correspond to the head of pendingTxns if it exists
     */
    public void commit(long zxid) {
<span class="pc bpc" id="L107" title="1 of 2 branches missed.">        if (pendingTxns.size() == 0) {</span>
<span class="nc" id="L108">            LOG.warn(&quot;Committing &quot; + Long.toHexString(zxid)</span>
                    + &quot; without seeing txn&quot;);
<span class="nc" id="L110">            return;</span>
        }
<span class="fc" id="L112">        long firstElementZxid = pendingTxns.element().zxid;</span>
<span class="pc bpc" id="L113" title="1 of 2 branches missed.">        if (firstElementZxid != zxid) {</span>
<span class="nc" id="L114">            LOG.error(&quot;Committing zxid 0x&quot; + Long.toHexString(zxid)</span>
                    + &quot; but next pending txn 0x&quot;
<span class="nc" id="L116">                    + Long.toHexString(firstElementZxid));</span>
<span class="nc" id="L117">            System.exit(12);</span>
        }
<span class="fc" id="L119">        Request request = pendingTxns.remove();</span>
<span class="fc" id="L120">        commitProcessor.commit(request);</span>
<span class="fc" id="L121">    }</span>
    
    synchronized public void sync(){
<span class="pc bpc" id="L124" title="1 of 2 branches missed.">        if(pendingSyncs.size() ==0){</span>
<span class="nc" id="L125">            LOG.warn(&quot;Not expecting a sync.&quot;);</span>
<span class="nc" id="L126">            return;</span>
        }
                
<span class="fc" id="L129">        Request r = pendingSyncs.remove();</span>
<span class="fc" id="L130">		commitProcessor.commit(r);</span>
<span class="fc" id="L131">    }</span>
             
    @Override
    public int getGlobalOutstandingLimit() {
<span class="fc" id="L135">        return super.getGlobalOutstandingLimit() / (self.getQuorumSize() - 1);</span>
    }
    
    @Override
    public void shutdown() {
<span class="fc" id="L140">        LOG.info(&quot;Shutting down&quot;);</span>
        try {
<span class="fc" id="L142">            super.shutdown();</span>
<span class="nc" id="L143">        } catch (Exception e) {</span>
<span class="nc" id="L144">            LOG.warn(&quot;Ignoring unexpected exception during shutdown&quot;, e);</span>
<span class="fc" id="L145">        }</span>
        try {
<span class="fc bfc" id="L147" title="All 2 branches covered.">            if (syncProcessor != null) {</span>
<span class="fc" id="L148">                syncProcessor.shutdown();</span>
            }
<span class="nc" id="L150">        } catch (Exception e) {</span>
<span class="nc" id="L151">            LOG.warn(&quot;Ignoring unexpected exception in syncprocessor shutdown&quot;,</span>
                    e);
<span class="fc" id="L153">        }</span>
<span class="fc" id="L154">    }</span>
    
    @Override
    public String getState() {
<span class="fc" id="L158">        return &quot;follower&quot;;</span>
    }

    @Override
    public Learner getLearner() {
<span class="fc" id="L163">        return getFollower();</span>
    }
}
</pre><div class="footer"><span class="right">Created with <a href="http://www.eclemma.org/jacoco">JaCoCo</a> 0.7.7.201606060606</span></div></body></html>